QGIS Application - Bug report #10976
attribute table refresh problems after edits
2014-07-29 03:56 PM - John Floyd -

Status: Closed

Priority: Severe/Regression
Assignee: Jurgen Fischer
Category: Attribute table

Affected QGIS version:master
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 19321

Description

This is a problem whether through the calculator or manual changes are made.

Edit an entry.
Table does not change - shows old entry.

Save it - layer on screen changes to new value (displayed as a label) - table still has old value.

(edit back to old value - nothing changes at all because the entered value is the same as the table is displaying)

Close attribute table, reopen new value is in table.

This problem occurs on manual edit or calulator edits.

During any table display | am getting an error that may be related to this behaviour.

ERROR 1: lllegalArgumentException: point array must contain 0 or >1 elements

Maybe related - the layer is shapefile.

Related issues:

Related to QGIS Application - Feature request # 11319: Allow to (re)add featu...
Related to QGIS Application - Bug report # 11939: Updating field values does ...

Closed
Closed

2014-10-03
2015-01-04

Associated revisions

Revision 2073c039 - 2015-02-10 06:27 PM - Jiirgen Fischer

attribute table: fix update of sort column (fixes #10976)

History

#1 - 2014-07-29 08:58 PM - John Floyd -

Further investigation seems to suggest that this issue is related to another independent layer, that generates the stated error on a canvas redraw - which

somehow in turn terminates the attribute table update - without crashing the application.

Not totally sure or clear on how this could evolve, but rebuilding the particular layer causes the Point error to disappear and the attribute table refresh than

works as expected. Very strange?

#2 - 2014-07-30 01:08 AM - Matthias Kuhn

Can you attach a project that demonstrates the problem?
#3 - 2014-07-30 04:37 AM - Giovanni Manghi

- Category changed from GUI to Vectors

- Status changed from Open to Feedback

- Target version deleted (Future Release - High Priority)
#4 - 2014-07-30 03:38 PM - John Floyd -

Further investigation shows a possible related problem - at least for shape files. This hickup was active in my setup, when the problem showed up.

If a layer item is geometrically edited - removing all its vertices say for a line, the attribute table still have the attribute entry for it. That is despite no

underlaying geometry data - the object still sort of exists.

Sorry still cant isolate a working example that causes the lock up in the attribute edit.

#5 - 2014-08-22 03:39 AM - V Charlet

- Target version set to Future Release - High Priority

Same problem with QGIS 2.2 and QGIS 2.4 on Windows, on several differents projects and different computers

#6 - 2014-10-03 02:37 AM - Frank Sokolic
| also get the same problem although | haven't been able to reproduce it consistently. Sometimes the table refreshes correctly, sometimes not. Upon saving

the table, closing it and then reopening it the updated edits are there. This is using shapefiles with QGIS 2.5.0-Master on Ubuntu 14.04.

#7 - 2014-10-03 11:22 AM - Giovanni Manghi

- Affected QGIS version changed from 2.4.0 to master

- Subject changed from attribute table problems refresh and updates after edits to attribute table refresh problems after edits
- Priority changed from Severe/Regression to High

- Operating System deleted (linux)

| also seen this issue a number of times, but struggled to replicate it. Anyway it is not a regression (so we should not tag this as blocker) because | clearly

remember to have seen this since... forever.

#8 - 2014-10-03 11:28 AM - Giovanni Manghi

If a layer item is geometrically edited - removing all its vertices say for a line, the attribute table still have the attribute entry for it. That is despite no

underlaying geometry data - the object still sort of exists.

this is certainly a regression on qgis 2.4/master, see #11319

#9 - 2014-10-11 07:54 AM - Giovanni Manghi
- Status changed from Feedback to Open

#10 - 2014-10-24 12:04 AM - Jiirgen Fischer
- Category changed from Vectors to Attribute table
#11 - 2014-10-29 03:06 PM - ramon .
This seems fairly reliable for me:
- Open an attribute table for a layer that you are editing.

- Any change you make now should become visible.

- Sort the attribute table by clicking on a header.

- Any change you make now won't be visible unless you reopen the attribute table.

No, sorting it back to how it started doesn't fix it either.

I'm fairly sure there are other ways of producing this, but that's the known repeatable one for me.

#12 - 2014-10-30 03:48 AM - Pedro Venéancio
ramon . wrote:
This seems fairly reliable for me: - Open an attribute table for a layer that you are editing.

- Any change you make now should become visible.

- Sort the attribute table by clicking on a header.
- Any change you make now won't be visible unless you reopen the attribute table.

No, sorting it back to how it started doesn't fix it either.

I'm fairly sure there are other ways of producing this, but that's the known repeatable one for me.

Hi Ramon,

I've been testing and | can confirm the behavior you describe.

| do not know if there are other causes for the problem, but this seems to be one of them.

#13 - 2014-11-03 02:28 PM - Giovanni Manghi

- Priority changed from High to Severe/Regression

- Target version changed from Future Release - High Priority to Version 2.8

ramon . wrote:
This seems fairly reliable for me:
- Open an attribute table for a layer that you are editing.
- Any change you make now should become visible.

- Sort the attribute table by clicking on a header.
- Any change you make now won't be visible unless you reopen the attribute table.

No, sorting it back to how it started doesn't fix it either.

I'm fairly sure there are other ways of producing this, but that's the known repeatable one for me.
confirmed, and | add that qgis 2.0.1 was working as expected.

#14 - 2014-12-10 03:47 AM - Filipe Dias

| received reports from users that thought Field Calculator was not working because of this bug. It is very annoying and may lead less persistent users to

think there is something seriously wrong.

#15 - 2014-12-10 03:48 AM - Filipe Dias

- Affected QGIS version changed from master to 2.6.1

#16 - 2014-12-10 09:56 AM - Giovanni Manghi

Filipe Dias wrote:

| received reports from users that thought Field Calculator was not working because of this bug. It is very annoying and may lead less persistent

users to think there is something seriously wrong.

it is a blocker, so it will certainly be fixed for 2.8

#17 - 2015-01-04 10:11 AM - Paolo Cavallini

See also #11939

#18 - 2015-01-19 01:58 AM - Giovanni Manghi
- Affected QGIS version changed from 2.6.1 to master

This also affects edit widgets like the value map: if a column has been sorted then choosing a entry from the value map combo box will not result in a filled

cell, unless sorting again or closing and reopening the table.

#19 - 2015-02-09 12:00 PM - Jiirgen Fischer
- Status changed from Open to Feedback

Tried with airports.shp from the sample data - with a value map on "use". Seems to work fine for me.
Sorting by "cat" doesn't change that the update are shown for me. Regardless whether | do manual edits or update via expression and/or the field
calculator.
#20 - 2015-02-09 12:43 PM - Giovanni Manghi
Jurgen Fischer wrote:
Tried with airports.shp from the sample data - with a value map on "use". Seems to work fine for me.

Sorting by "cat" doesn't change that the update are shown for me. Regardless whether | do manual edits or update via expression and/or the field
calculator.
see the following cast

https://www.dropbox.com/s/2psjltcwmpgu619/value_map_refresh.mp4?dI=0

#21 - 2015-02-10 02:46 AM - Jiirgen Fischer
- Assignee set to Jirgen Fischer
- Status changed from Feedback to Open

#22 - 2015-02-10 09:35 AM - Jiirgen Fischer
- Status changed from Open to Closed

Fixed in changeset commit:"2073c03931c6ee6dedd6d1b87365686ab49386f4".

#23 - 2017-01-17 04:52 AM - Ger CO

still an issue in 2.18.x.

And rather consistent when using shapefiles.

Features regularly are temporarily missing

in attribute table after making and saving edits

despite being displayed on map canvas.

Reloading shp fixes the issue until next edits are made.

Severe issue!

#24 - 2017-10-05 11:01 AM - Loic Bouffard

Work in 2.18.9 and still the same issue...

The same thing passing by 2 ways: copying and join two shapefiles, at the end some attributes are missing.
It works after closing QGIS and re opening but | don't know why is this appening and it's impossible to predict when it will be.

Hope this old problem will be fixed soon.
https://www.dropbox.com/s/2psjltcwmpgu619/value_map_refresh.mp4?dl=0

